<template lang="html">
  <div id="profile-params">
    <div class="field is-vertical">
      <label class="label">Mettre à jour votre photo de profil :</label>
      <div class="field-body">
        <figure class="image is-96x96">
          <img v-if="newProfilePict.blob" :src="newProfilePict.blob" alt="profile picture blob">
          <img v-if="!newProfilePict.blob && profile.profilePicture.url!=''" :src="'http://localhost:3000/profile-pictures/'+profile.profilePicture.url" alt="profile picture">
        </figure>
        <div class="field upload-btn-ctn">
          <div class="control">
            <div class="file">
              <label class="file-label">
                <input class="file-input" type="file" name="resume" @change="getInputFile($event)" accept="image/*">
                <span class="file-cta">
                  <span class="file-icon">
                    <i class="fas fa-upload"></i>
                  </span>
                  <span class="file-label">
                    choisir une image...
                  </span>
                </span>
              </label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="field">
      <label class="label">Décrivez votre activité :</label>
      <div class="control">
        <textarea class="textarea" placeholder="Textarea" v-model="updatedFields.informations.description"></textarea>
      </div>
    </div>
    <b-field :label="tagsLabel">
      <b-taginput
          v-model="updatedFields.informations.tags"
          placeholder="Rock ...">
      </b-taginput>
    </b-field>
    <div class="field" v-if="profile.type=='artist'">
      <label class="label">Combien de musicien(s) vous êtes :</label>
      <div class="control">
        <input class="input"  min="1" type="number" name="" v-model="updatedFields.informations.group">
      </div>
    </div>
    <b-field label="Listez le matériel dont vous disposez">
      <b-taginput
          v-model="updatedFields.informations.material"
          placeholder="Guitare electrique ...">
      </b-taginput>
    </b-field>
    <div class="field">
      <label class="label">Des requêtes ou besoins particuliers c'est ici :</label>
      <div class="control">
        <textarea class="textarea" placeholder="Nous aurions besoin d'une table de mixage, un micro ..." v-model="updatedFields.informations.needs"></textarea>
      </div>
    </div>
    <div class="field">
      <div class="control">
        <button class="button is-link is-medium" @click="updateProfile()">Valider</button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations } from 'vuex'
import Api from '@/api/Api'
import { getInputFile } from '@/assets/utils'
export default {
  name: 'ProfileParams',
  props: ['profile'],
  data(){
    return {
      newProfilePict:{},
      informationsMockUp:{
        description:null,
        tags:[],
        group:null,
        material:[],
        needs:null
      }
    }
  },
  computed: {
    updatedFields(){
      return { informations: {...this.informationsMockUp, ...this.profile.informations} }
    },
    tagsLabel(){
      return this.profile.type=='artist'?'Décrivez votre style musical en quelques tags':'Donner une liste de ce que vous recherchez en quelques tags'
    }
  },
  methods: {
    ...mapMutations('profile',['setAuthedProfile']),
    updateProfile(){
      var newProfile = { ...this.profile , ...this.updatedFields };
      return Api.auth().put('/update',newProfile).then((res) =>
        {
          if(this.updatedFields.profilePicture){
            newProfile.informations.blob = this.newProfilePict.blob;
            this.uploadProfilePicture();
          }
          this.setAuthedProfile(newProfile);
        }).catch((res) => {
          return res
        })
    },
    uploadProfilePicture(){
      const formData = new FormData();
      formData.append("uploads[]", this.newProfilePict.input, this.updatedFields.profilePicture.url);
      return Api.auth().post('/upload_profile_picture',formData).then((res) =>
        {
        }).catch((res) => {
          return res
        })
    },
    getInputFile(event){
      if(getInputFile(event)){
        var profilePictureName = Date.now().toString()+'_'+this.profile._id+'.jpg';
        this.newProfilePict = getInputFile(event);
        this.updatedFields.profilePicture = {url:profilePictureName};
      }
    }
  }
}
</script>

<style lang="scss" scoped>
#profile-params{
  width: 65%;
  margin: auto;
  figure {
    margin-right: 1rem;
    img{
      border-radius: 100%;
      width: 96px;
      height: 96px;
    }
  }
  .upload-btn-ctn{
    display: flex;
    align-items: center;
  }
}
</style>
